
#include "AEEModGen.h" 
#include "AEEAppGen.h" 
#include "AEEDisp.h"   
#include "hello.bid" 


//Function prototype
static boolean HelloWorld_HandleEvent( IApplet * pi, 
									   AEEEvent eCode,
									   uint16 wParam, 
									   uint32 dwParam );


// This constructor is launched by the BREW shell, it creates an insatnce of this class
 
int AEEClsCreateInstance( AEECLSID clsID,
						  IShell * pIShell,
						  IModule * po,
						  void ** ppObj )
{
	boolean result = FALSE;
	*ppObj = NULL;

	// Check classID
	if( clsID == AEECLSID_HELLOWORLD )
	{
		
		// Create  instance of class with BREW helper function
		result= AEEApplet_New( sizeof(AEEApplet),
			                   clsID, 
                               pIShell,
							   po,
							   (IApplet**)ppObj, 
							   (AEEHANDLER)HelloWorld_HandleEvent,
							   NULL);
	}
	return result ? AEE_SUCCESS : EFAILED;
}

 
//Handles incoming events from shell
static boolean HelloWorld_HandleEvent( IApplet *pi,
									   AEEEvent eCode,
									   uint16 wParam, 
									   uint32 dwParam )
{
	AECHAR szBuf[] = {'H','e','l','l','o',' ',
			          'W','o','r','l','d','\0'};
	AEEApplet * pMe = (AEEApplet*)pi;
	boolean handled = FALSE;

  
  wParam;
  dwParam;

	// Incoming event detection.
	switch (eCode)
	{
		// Launch application
		case EVT_APP_START: 
			// Clear display.
			IDISPLAY_ClearScreen( pMe->m_pIDisplay ); 
			// Display string on screen
			IDISPLAY_DrawText( pMe->m_pIDisplay, 
							   AEE_FONT_BOLD, 
							   szBuf,
							   -1, 0, 0, 0, 
							   IDF_ALIGN_CENTER | IDF_ALIGN_MIDDLE );
			// Redraw display to show drawn text
			IDISPLAY_Update (pMe->m_pIDisplay); 
			handled = TRUE;

		// Close Application
		case EVT_APP_STOP:
			handled = TRUE;

		default:
			break;
	}
	return handled;
}
